//
// A class to handle a foot pedal masquerading as an external keyboard
//

#import <UIKit/UIKit.h>

enum {
  kArrowKeyUp,
  kArrowKeyDown,
  kArrowKeyLeft,
  kArrowKeyRight,
};

@protocol KeyboardHandlerDelegate;

@protocol KeyboardHandlerDelegate <NSObject>
@optional
- (void)didReceiveKey:(NSString*)key;
- (void)didReceiveArrowKey:(int)key;
@end

@interface KeyboardHandler : UIView <UITextViewDelegate>
{
  id <KeyboardHandlerDelegate> delegate;
  UIView* _inputView;
  UITextView* _textView;
  BOOL _handleArrows;
}

-(id)initWithDelegate:(id)aDelegate;
-(void)makeFirstResponder;

@property (nonatomic, assign) id <KeyboardHandlerDelegate> delegate;

@end
