#import "Tunebook.h"
#import <UIKit/UIKit.h>

@class TuneViewController;
@class Tune;
@class Playlist;

@interface MainViewController : UIViewController <UITableViewDelegate, UITableViewDataSource, UIActionSheetDelegate, UIAlertViewDelegate>
{
	NSMutableArray *menuList;
	IBOutlet UITableView *tableView;
	IBOutlet UISearchBar *searchBar;
	IBOutlet UIBarButtonItem *searchButton;
	IBOutlet UIBarButtonItem *manageButton;
  IBOutlet UIBarButtonItem *bookmarkButtonItem;

//#if TUNEBOOK_MULTI_SELECT
  IBOutlet UIToolbar *editingToolbar;
//#endif

  // For iPad
  IBOutlet UIToolbar *toolbar;
  IBOutlet UIBarButtonItem *playSettingsItem;
  IBOutlet UIBarButtonItem *playButton;
  IBOutlet UIBarButtonItem *stopButton;
  IBOutlet UIBarButtonItem *addTuneButton;
  IBOutlet UISegmentedControl *sortOrder;
  NSMutableArray* playItems;
  NSMutableArray* stopItems;
  //

	NSMutableArray* listContent;
	NSMutableArray* filteredListContent;
  Playlist *playlist;
  BOOL loading;
  Playlist *choosingTunes;
  NSInteger sectionCount;
  NSInteger sectionIndex[101];
  NSMutableArray* sectionIndexTitles;
  int transitionDirection;

  IBOutlet UIBarButtonItem *_editMoveButton;
  IBOutlet UIBarButtonItem *_editDeleteButton;
  NSInteger _activeActionSheetType;
  NSInteger _addToTunebookIndex;
  NSInteger _addToNewTunebookIndex;
}

@property (nonatomic, retain) UITableView *tableView;
@property (nonatomic, retain) UISearchBar *searchBar;

@property (nonatomic, retain) NSArray *listContent;
@property (nonatomic, retain) NSMutableArray *filteredListContent;

@property (nonatomic, retain) Playlist *playlist;

@property (nonatomic, retain) Playlist *choosingTunes;

+ (MainViewController*)activeController;

- (void)databaseChanged:(id)sender;
- (UITableViewCell *)tableviewCellWithReuseIdentifier:(NSString *)identifier;

- (void)setPlaylist:(Playlist *)playlist;

- (IBAction)donePressed:(id)sender;
- (IBAction)cancelPressed:(id)sender;
- (IBAction)bookmarkPressed:(id)sender;

- (IBAction)prevTune:(id)sender;
- (IBAction)nextTune:(id)sender;

- (void)buildSectionIndex;

- (void)filterTunes;

- (IBAction)addNewTune:(id)sender;

- (int)tuneSortOrder;

- (IBAction)searchPressed:(id)sender;
- (IBAction)settingsPressed:(id)sender;
- (IBAction)playSettingsPressed:(id)sender;
- (IBAction)playPressed:(id)sender;
- (IBAction)stopPressed:(id)sender;
- (IBAction)actionPressed:(id)sender;
- (IBAction)editPressed:(id)sender;
- (IBAction)emailPressed:(id)sender;
- (IBAction)sortOrderChanged:(id)sender;

- (Tune*)selectedTune;
- (NSArray*)selectedTunes;

#if TUNEBOOK_MULTI_SELECT
- (IBAction)deletePressed:(id)sender;
- (IBAction)deleteSelectedTunes:(id)sender;
- (IBAction)movePressed:(id)sender;
#endif

@end
