#import <sqlite3.h>
#import <UIKit/UIKit.h>
#import "Tunebook.h"
#import "Playlist.h"

@class Tune;
@class TuneViewController;
@class PlaylistDetailsController;
@class MainViewController;

@interface PlaylistViewController : UIViewController <UITableViewDelegate, UITableViewDataSource, UIActionSheetDelegate, UIAlertViewDelegate>
{
	IBOutlet UITableView *tableView;
  IBOutlet PlaylistDetailsController *detailsController;

  IBOutlet UINavigationController *navigationController;
  IBOutlet UIToolbar *toolbar;
  IBOutlet UIBarButtonItem *playSettingsItem;
  IBOutlet UIBarButtonItem *playButton;
  IBOutlet UIBarButtonItem *stopButton;
  NSMutableArray* playItems;
  NSMutableArray* stopItems;

  IBOutlet UISearchBar *searchBar;
  IBOutlet UITableViewCell *allTunesCell;

  NSMutableArray *listContent;
  NSMutableArray *filteredListContent;

  NSArray *addingTunes;

#if TUNEBOOK_ASK_DELETE
  NSIndexPath* _indexToDelete;
#endif
  BOOL _ignoreAccessoryTap; // Hack to work round accessory button bug
}

@property (nonatomic, retain) UITableView *tableView;
@property (nonatomic, retain) NSMutableArray *listContent;
@property (nonatomic, retain) UISearchBar *searchBar;
@property (nonatomic, retain) NSArray *addingTunes;

- (UITableViewCell *)tableviewCellWithReuseIdentifier:(NSString *)identifier;
- (void)databaseChanged:(id)sender;
- (IBAction)addTunebook:(id)sender;

- (IBAction)searchPressed:(id)sender;
- (IBAction)settingsPressed:(id)sender;
- (IBAction)playSettingsPressed:(id)sender;
- (IBAction)playPressed:(id)sender;
- (IBAction)stopPressed:(id)sender;
- (IBAction)actionPressed:(id)sender;

- (void)selectTunebook:(int)aTunebookPrimaryKey;

- (void)filterTunebooks;

- (void)createNewTunebook;
- (void)createNewTunebookWithName:(NSString*)name;

- (void)renameTunebook:(Playlist*)tunebook;
- (void)renameTunebookWithName:(NSString*)name;

@end

@interface PlaylistDetailsController : UITableViewController <UITextFieldDelegate>
{
  Playlist* playlist;
  UITextField* textField;
  UITableView* tableView;
  NSIndexPath* indexPath;
}

@property (nonatomic, retain) Playlist* playlist;
@property (nonatomic, retain) UITableView* tableView;
@property (nonatomic, retain) NSIndexPath* indexPath;

@end

