#import "SearchViewController.h"
#import "PlaylistViewController.h"
#import "MainViewController.h"
#import "AppDelegate.h"

@implementation SearchViewController

- (CGSize)contentSizeForViewInPopoverView {
  return CGSizeMake(320.0, 440.0);
}

- (void)viewDidLoad
{
  [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillShow:) name:UIKeyboardWillShowNotification object:nil];
  [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillHide:) name:UIKeyboardWillHideNotification object:nil];
  self.navigationItem.title = @"Search";
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
  return NO;
}

- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning];
}

-(void)dealloc {
	[super dealloc];
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
  AppDelegate *appDelegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
  [textField resignFirstResponder];
  Playlist *playlist = [[Playlist alloc] initWithName:textField.text abc:abcSearchText.text title:titleSearchText.text key:keySearchText.text meter:meterSearchText.text database:appDelegate.database];

  if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
    MainViewController *controller = [[MainViewController alloc] initWithNibName:@"MainViewToolbar" bundle:nil];
    controller.playlist = playlist;
    [self.navigationController pushViewController:controller animated:YES];
  }
  else {
    MainViewController *controller = [[MainViewController alloc] initWithNibName:@"MainView" bundle:nil];
    controller.playlist = playlist;
    [appDelegate.navigationController pushViewController:controller animated:YES];
  }
  return YES;
}

- (void)keyboardWillShow:(NSNotification *)notification
{
  AppDelegate *appDelegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
  if ( !self.view.hidden )
    appDelegate.topViewController.navigationItem.rightBarButtonItem = cancelButton;
}

- (void)keyboardWillHide:(id)sender
{
  AppDelegate *appDelegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
  if ( !self.view.hidden )
    appDelegate.topViewController.navigationItem.rightBarButtonItem = nil;
}

- (void)cancelPressed:(id)sender
{
  [abcSearchText resignFirstResponder];
  [titleSearchText resignFirstResponder];
  [keySearchText resignFirstResponder];
  [meterSearchText resignFirstResponder];
}

@end
