//
//  TopLevelViewController.m
//  Tunebook
//
//  Created by Jerry on 29/12/2012.
//
//

#import "TopLevelViewController.h"
#import "PlaylistViewController.h"
#import "TuneViewController.h"
#import <QuartzCore/QuartzCore.h>
#if 1//FIXME
#import "AppDelegate.h"
#endif

@interface TopLevelViewController ()

@end

@implementation TopLevelViewController

@synthesize tunebookViewController;
@synthesize tuneViewController;
@synthesize navigationController;
@synthesize leftView;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
  [super viewDidLoad];

  [tunebookViewController viewDidLoad];//FIXME-why doesn't this get called by default?

  leftView.layer.cornerRadius = 4.0f;

  // Create the sliding left view in code because UINavigationController in IB is tricky
  tunebookViewController = [[PlaylistViewController alloc] initWithNibName:@"PlaylistViewToolbar" bundle:nil];
  [tunebookViewController databaseChanged:self];
  navigationController = [[UINavigationController alloc] initWithRootViewController:tunebookViewController];
  navigationController.navigationBar.translucent = FALSE;
  navigationController.toolbar.translucent = FALSE;
  CGRect bounds = self.view.bounds;
  bounds.size.width = 320;
	navigationController.view.frame = bounds;
	navigationController.view.autoresizingMask = UIViewAutoresizingFlexibleTopMargin|UIViewAutoresizingFlexibleHeight;
	[leftView addSubview: navigationController.view];
	navigationController.view.frame = CGRectMake(0.0f, 0.0f, 319, navigationController.view.frame.size.height);
  [self addChildViewController:navigationController];
  leftViewVisible = YES;
}

- (void)didReceiveMemoryWarning
{
  [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
  return YES;
}

- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration
{
  [tuneViewController willRotateToInterfaceOrientation:toInterfaceOrientation duration:duration];
}

- (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation
{
  [tuneViewController didRotateFromInterfaceOrientation:fromInterfaceOrientation];
}

- (CGSize)getContentSize
{
  CGSize contentSize = self.view.frame.size;
  UIDeviceOrientation myOrientation = [[UIDevice currentDevice] orientation];
  if (myOrientation == UIDeviceOrientationLandscapeLeft || myOrientation == UIDeviceOrientationLandscapeRight) {
    float newHeight = contentSize.width;
    contentSize.width = contentSize.height;
    contentSize.height = newHeight;
  }
  return contentSize;
}

- (void)showLeftView:(BOOL)visible
{
  if ( visible != leftViewVisible ) {
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationDuration:0.3f];
    if ( leftViewVisible ) {
      leftViewVisible = NO;
      leftView.frame = CGRectMake(-leftView.frame.size.width, 0.0f, leftView.frame.size.width, leftView.frame.size.height);
      [leftView endEditing:YES]; // Hide the keyboard if a subview has it open
    }
    else {
      leftViewVisible = YES;
      leftView.frame = CGRectMake(0, 0.0f, leftView.frame.size.width, leftView.frame.size.height);
    }
    [UIView commitAnimations];
    [self zoomModeChanged];
  }
}

- (void)toggleLeftView
{
  [self showLeftView:!leftViewVisible];
}

- (void)zoomModeChanged
{
  AppDelegate *appDelegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
  CGRect r = rightView.frame;
  if ( leftViewVisible && appDelegate.zoomTuneWithIndexKey ) {
    r.origin.x = 320;
    r.size.width = self.view.bounds.size.width-320;
  }
  else {
    r.origin.x = 0;
    r.size.width = self.view.bounds.size.width;
  }
  if ( rightView.frame.origin.x != r.origin.x ) {
    rightView.frame = r;
    [tuneViewController zoomToFit:self];
  }
}

@end
