//
//  TransposeViewController.m
//  Tunebook
//
//  Created by Jerry on 16/11/2013.
//
//

#import "TransposeViewController.h"
#import "EditABCController.h"

@interface TransposeViewController ()

@end

@implementation TransposeViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
  self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
  if (self) {
      // Custom initialization
  }
  return self;
}

- (void)viewDidLoad
{
  [super viewDidLoad];
  _sharpFlat.selectedSegmentIndex = 1;
  [self controlsChanged];
}

- (void)dealloc
{
  [_editController release];
  [_originalTune release];
  [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void)setEditController:(EditABCController*)controller;
{
  _editController = [controller retain];
  _originalTune = [[_editController text] retain];
}

-(IBAction)controlsChanged
{
  BOOL semitones = _method.selectedSegmentIndex == 1;
  [_semitones setHidden:!semitones];
  [_keys setHidden:semitones];
  [_sharpFlat setHidden:semitones];
  char transposeSpec[32];
  transposeSpec[0] = _upDown.selectedSegmentIndex == 0 ? '^' : '_';

  if ( semitones ) {
    NSInteger n = _semitones.selectedSegmentIndex+1;
    if ( _upDown.selectedSegmentIndex == 1 && n == 1 )
      n = 11;//FIXME-no idea why we have to do this
    sprintf( &transposeSpec[1], "%ld", (long)n );
  }
  else {
    NSInteger key = _keys.selectedSegmentIndex;
    strcpy( &transposeSpec[1], [[_keys titleForSegmentAtIndex:key] UTF8String] );
    BOOL hasFlat = key != 2 && key != 5;
    BOOL hasSharp = key != 1 && key != 4;
    [_sharpFlat setEnabled:hasFlat forSegmentAtIndex:0];
    [_sharpFlat setEnabled:hasSharp forSegmentAtIndex:2];
    if ( _sharpFlat.selectedSegmentIndex == 0 )
      strcat( transposeSpec, "b" );
    else if ( _sharpFlat.selectedSegmentIndex == 2 )
      strcat( transposeSpec, "#" );
  }
  [_editController transpose:_originalTune spec:transposeSpec];
}

-(IBAction)cancelPressed
{
  [_editController setText:_originalTune];
  [self.view removeFromSuperview];
  [self removeFromParentViewController];
//  [self dismissViewControllerAnimated:YES completion:0];
}

-(IBAction)transposePressed
{
  [self.view removeFromSuperview];
  [self removeFromParentViewController];
//  [self dismissViewControllerAnimated:YES completion:0];
}

@end
