#import "UIImage+iOS7.h"
#import <objc/objc-runtime.h>
 
static Method origImageNamedMethod = nil;
static Method sOrigImageWithContentsOfFile = nil;

@implementation UIImage (Retina4)
 
+ (void)load
{
  origImageNamedMethod = class_getClassMethod(self, @selector(imageNamed:));
  method_exchangeImplementations(origImageNamedMethod,
                                 class_getClassMethod(self, @selector(retina4ImageNamed:)));
  sOrigImageWithContentsOfFile = class_getClassMethod(self, @selector(imageWithContentsOfFile:));
  method_exchangeImplementations(sOrigImageWithContentsOfFile,
                                 class_getClassMethod(self, @selector(myImageWithContentsOfFile:)));
}
                                                   
+ (UIImage *)myImageWithContentsOfFile:(NSString *)path
{
  NSLog(@"Loading image named => %@", path);
  return [UIImage imageWithContentsOfFile:path];
}

+ (UIImage *)retina4ImageNamed:(NSString *)imageName
{
  NSLog(@"Loading image named => %@", imageName);
  NSMutableString *imageNameMutable = [imageName mutableCopy];
  NSRange retinaAtSymbol = [imageName rangeOfString:@"@"];
  [imageNameMutable replaceOccurrencesOfString:@".png" withString:@"-ios7.png" options:NSLiteralSearch range:NSMakeRange(0, imageNameMutable.length)];
  NSString *imagePath = [[NSBundle mainBundle] pathForResource:imageNameMutable ofType:@"png"];
  if (imagePath) {
      return [UIImage retina4ImageNamed:imageNameMutable];
  } else {
      return [UIImage retina4ImageNamed:imageName];
  }
  return nil;
}

@end