#import <Cocoa/Cocoa.h>
#import "TuneParser.h"

@class Tune;
@class Playlist;
@class TuneDatabase;

@interface ImportProgressController : NSViewController <TuneParserDelegate>
{
  TuneDatabase* _database;
  Playlist* _tunebook;
  NSURL *_url;
  NSURLConnection *urlConnection;
  long bytesRead;
  long bytesProcessed;
  long bytesToRead;
  BOOL lastWasCR;
  int numTunes;
  BOOL cancelled;
  BOOL finished;
  NSInteger statusCode;
  TuneParser *parser;
  NSMutableArray *parsedTunes;
  NSMutableString *fragment;
  NSWindow* _window;

  IBOutlet NSButton *cancelButton;
  IBOutlet NSProgressIndicator *progressView;
  IBOutlet NSTextField *statusLabel;
  IBOutlet NSTextField *titleLabel;
}

- (void) import:(NSURL *)url intoTunebook:(Playlist*)tunebook withDatabase:(TuneDatabase*)database window:(NSWindow*)window;

- (IBAction) onCancel:(id)sender;

- (void) threadRun:(id)sender;
- (void) updateProgress:(id)sender;

- (void) connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response;
- (void) connection:(NSURLConnection *)connection didReceiveData:(NSData *)data;
- (void) connection:(NSURLConnection *)connection didFailWithError:(NSError *)error;
- (NSCachedURLResponse *) connection:(NSURLConnection *)connection willCacheResponse:(NSCachedURLResponse *)cachedResponse;
- (void) connectionDidFinishLoading:(NSURLConnection *)connection;

- (void) parsedTune:(TuneParser *)parser tune:(Tune *)tune;
- (void) finishedImport:(id)sender;

@end
