//
//  PianoKeyboardView.m
//  Tunebook-Mac
//
//  Created by jerry on 23/12/2013.
//
//

#import "PianoKeyboardView.h"

@implementation PianoKeyboardView

static NSImage* sKeyBlack[2];
static NSImage* sKeyWhite[2];

- (id)initWithFrame:(NSRect)frame
{
  self = [super initWithFrame:frame];
  if (self) {
      // Initialization code here.
    sKeyBlack[0] = [NSImage imageNamed:@"KeyUpBlack.png"];
    sKeyBlack[1] = [NSImage imageNamed:@"KeyDownBlack.png"];
    sKeyWhite[0] = [NSImage imageNamed:@"KeyUpWhite.png"];
    sKeyWhite[1] = [NSImage imageNamed:@"KeyDownWhite.png"];
  }
  return self;
}

- (void)drawRect:(NSRect)dirtyRect
{
  [super drawRect:dirtyRect];
	
  [[NSColor whiteColor] set];
  NSRectFill( dirtyRect );
  
  CGFloat x = 0.0f;
  CGFloat y = 0.0f;
  CGFloat w = 24.0f;
  CGFloat h = 100.0f;
  int state = 0;
  
  NSImage* image;
  CGSize size;
  for ( int i = 0; i < 50; i++ ) {
    state = ( i == 7 );
    image = sKeyWhite[state];
    size = image.size;
    switch ( i % 11 ) {
      case 0:
      case 2:
      case 4:
      case 5:
      case 7:
      case 9:
        [image drawInRect:CGRectMake(x, y+100-h, w, h) fromRect:CGRectMake(0.0f, 0.0f, size.width, size.height) operation:NSCompositeSourceOver fraction:1.0f];
          x += w;
        break;
      case 1:
      case 3:
      case 6:
      case 8:
      case 10:
        break;
    }
  }

  size = image.size;
  x = w/2.0f;
  h = 60;
  for ( int i = 0; i < 50; i++ ) {
    state = ( i == 10 );
    image = sKeyBlack[state];
    size = image.size;
    switch ( i % 11 ) {
      case 0:
      case 2:
      case 5:
      case 7:
        break;
      case 4:
      case 9:
        x += w;
        break;
      case 1:
      case 3:
      case 6:
      case 8:
      case 10:
        [image drawInRect:CGRectMake(x+0.2f*w, y+100-h, 0.6f*w, h) fromRect:CGRectMake(0.0f, 0.0f, size.width, size.height) operation:NSCompositeSourceOver fraction:1.0f];
        x += w;
        break;
    }
  }
}

@end
