#import "SimpleSearchWindowController.h"
#import "TuneDatabase.h"
#import "Playlist.h"

@implementation SimpleSearchWindowController

@synthesize tunebook;
@synthesize delegate;

-(void)dealloc {
  [tunebook release];
  [delegate release];
	[super dealloc];
}

- (void) awakeFromNib
{
  if ( tunebook ) {
    [smartTunebookName setStringValue:tunebook.name];
    [abcSearchText setStringValue:tunebook.abcSearchText];
    [titleSearchText setStringValue:tunebook.titleSearchText];
    [keySearchText setStringValue:tunebook.keySearchText];
    [meterSearchText setStringValue:tunebook.meterSearchText];
  }
}

- (void)showSearch:(Playlist*)aTunebook window:(NSWindow*)aWindow
{
  self.tunebook = aTunebook;

  NSWindow* sheet = [self window];
  [NSApp beginSheet:sheet
         modalForWindow:aWindow
         modalDelegate:self
         didEndSelector: @selector(didEndSheet:returnCode:contextInfo:)
         contextInfo: NULL];
}

- (IBAction) searchPressed:(id)sender
{
  Playlist *t;
  if ( tunebook ) {
    tunebook.name = [smartTunebookName stringValue];
    tunebook.abcSearchText = [abcSearchText stringValue];
    tunebook.titleSearchText = [titleSearchText stringValue];
    tunebook.keySearchText = [keySearchText stringValue];
    tunebook.meterSearchText = [meterSearchText stringValue];
    if ( [smartTunebookButton state] )
      [tunebook.database addPlaylist:tunebook];
    t = tunebook;
  }
  else
    t = [[Playlist alloc] initWithName:[smartTunebookName stringValue] abc:[abcSearchText stringValue] title:[titleSearchText stringValue] key:[keySearchText stringValue] meter:[meterSearchText stringValue] database:nil];
  NSWindow* sheet = [self window];
  [NSApp endSheet:sheet];
  [delegate setPlaylist:t select:[smartTunebookButton state]];
}

- (IBAction) cancelPressed:(id)sender
{
  NSWindow* sheet = [self window];
  [NSApp endSheet:sheet];
}

- (void)didEndSheet:(NSWindow *)sheet returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo
{
  [sheet orderOut:self];
}

@end
