//
//  TuneListViewController.h
//  Tunebook-Mac
//
//  Created by Jerry on 22/07/2011.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <AudioToolbox/AudioToolbox.h>
#import "TuneParser.h"

@class TuneDatabase;
@class TuneView;
@class Tune;
@class Playlist;

@interface TuneListViewController : NSViewController <TuneParserDelegate, NSOutlineViewDataSource, NSTableViewDataSource, NSTableViewDelegate, NSTextFieldDelegate, NSTextViewDelegate> {
  IBOutlet TuneView* tuneView;
  IBOutlet NSScrollView* tuneScrollView;
  IBOutlet NSTableView* tuneListView;
  IBOutlet NSSearchField* searchField;
  IBOutlet NSTableView* tunebookView;
  IBOutlet NSButton* addTunebookButton;
  IBOutlet NSScrollView* abcScrollView;
  IBOutlet NSTextView* abcTextView;
  IBOutlet NSSplitView* abcSplitView;
  IBOutlet NSButton* _saveButton;
  TuneDatabase* database;
  Playlist* playlist;
  NSMutableArray* listContent;
  NSMutableArray* filteredListContent;
  BOOL tuneModified;

  NSMutableArray* parsedTunes;

  NSData *musicData;

  Tune* currentTune;
  Tune* pendingTune;
  NSInteger currentRow;
}

@property (nonatomic,retain) TuneDatabase* database;
@property (nonatomic, retain) Tune* currentTune;
@property (nonatomic, retain) NSTextView* abcTextView;

- (void)setTune:(Tune*)tune;

- (Tune*)selectedTune;
- (NSArray*)selectedTunes;
- (Tune*)tuneWithSelectedTunes;

- (IBAction)play:(id)sender;
- (IBAction)addTunebook:(id)sender;
- (IBAction)removeTunebook:(id)sender;
- (IBAction)newTune:(id)sender;
- (IBAction)removeTune:(id)sender;
- (IBAction)printTune:(id)sender;
- (IBAction)delete:(id)sender;
- (IBAction)showPlaySettings:(id)sender;
- (IBAction)saveTunes:(id)sender;
- (IBAction)saveTunesAsMIDI:(id)sender;
- (IBAction)saveTunesAsPDF:(id)sender;
//- (IBAction)saveTunesAsImages:(id)sender;
- (IBAction)saveEditedTune:(id)sender;

- (void)finishedPlaying:(id)sender;

- (void)setPlaylist:(Playlist *)aPlaylist select:(BOOL)aSelect;
- (void)setPlaylist:(Playlist *)aPlaylist;

- (int) rowForTunebook:(Playlist*)tunebook;

- (void)filterTunes;

@end
