//
//  Tunelayer.m
//  Tunebook-Mac
//
//  Created by Jerry on 22/07/2011.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#include <AudioUnit/AudioUnit.h>
#include <AudioToolbox/AudioToolbox.h>

extern NSString* kTunePlayerFinishedNotification;

@interface TunePlayerItem : NSObject
{
}

- (NSData*)data;
@end

@interface TunePlayer : NSObject
{
  NSInteger instrument;
  NSInteger chordInstrument;
  float speed;
  BOOL loop;
  BOOL shuffle;
  BOOL chords;

  MusicPlayer musicPlayer;
  MusicSequence musicSequence;
  AUGraph graph;
  AudioUnit synthUnit;
  
  NSArray* items;
  NSInteger currentItem;
}

@property(nonatomic,retain) NSArray* items;
@property(readwrite) NSInteger instrument;
@property(readwrite) NSInteger chordInstrument;
@property(readwrite) float speed;
@property(readwrite) BOOL loop;
@property(readwrite) BOOL shuffle;
@property(readwrite) BOOL chords;

+ (TunePlayer *)sharedInstance;

- (void)play;
- (void)stop;
- (BOOL)isPlaying;

- (void)transpose:(NSInteger)delta;

- (void)setSMFData:(NSData*)smfData;

- (void)endOfSequence;

@end
