#import <QuartzCore/QuartzCore.h>
#import "TuneView.h"
#import "Tune.h"

// Sizes for A4 paper
#define PaperWidth 592
#define PaperHeight 842

@implementation TuneView

@synthesize delegate, scale, tune, numPages;

-(void)dealloc
{
  [tune release];
  [super dealloc];
}

-(BOOL)acceptsFirstResponder
{
    return YES;
}

- (void)scrollWheel:(NSEvent *)theEvent
{
  [[self enclosingScrollView] scrollWheel:theEvent];
}

-(void)drawRect:(CGRect)rect
{
  CGRect bounds = self.bounds;
  NSGraphicsContext* nsGraphicsContext = [NSGraphicsContext currentContext];
  CGContextRef context = (CGContextRef) [nsGraphicsContext graphicsPort];

  CGContextSaveGState( context );

  CGContextSetRGBFillColor( context, 1.0, 1.0, 1.0, 1.0 );
  CGContextFillRect( context, bounds );

  scale = 1;
//  sErrorLine = -1;

  if ( tune ) {
    CGContextSetLineWidth( context, 1.0f );

    CGContextTranslateCTM( context, 0.0, bounds.size.height-PaperHeight*scale ); // Translate to one page from the top
    CGContextScaleCTM( context, scale, scale );

#if 0
    TuneFormatter* formatter = [[TuneFormatter alloc] init];
    [formatter drawTune:tune intoContext:context bounds:bounds scale:self.scale paginate:YES];
    [formatter release];
#else
    [Tune drawTune:tune intoContext:context bounds:bounds scale:self.scale paginate:YES];
#endif

    CGContextSetRGBFillColor( context, 0.9f, 0.9f, 0.9f, 1.0 );
    CGContextSetRGBStrokeColor( context, 0.9f, 0.9f, 0.9f, 1.0 );

    for ( int y = PaperHeight; y < bounds.size.height/scale+1; y += PaperHeight ) {
      CGContextMoveToPoint( context, 0, y );
      CGContextAddLineToPoint( context, bounds.size.width/scale, y );
    }
    CGContextStrokePath( context );
  }

  CGContextRestoreGState( context );
//  if ( sErrorLine != -1 ) {
//    CGContextSetRGBFillColor( context, 1.0f, 0.0f, 0.0f, 1.0 );
//    CGContextSetRGBStrokeColor( context, 1.0f, 0.0f, 0.0f, 1.0 );
//    extern void drawUIText( CGContextRef context, float x, float y, const char *text, int alignment, bool serif, int fontSize, bool utf8charset );
//NSLog(sErrorMsg);
//    [sErrorMsg drawAtPoint:NSMakePoint( 100, 100 ) withAttributes:nil];
//  }

}

@end

