//
//  Tunebook_MacAppDelegate.m
//  Tunebook-Mac
//
//  Created by Jerry on 22/07/2011.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Tunebook_MacAppDelegate.h"
#import "PluginManager.h"

@implementation Tunebook_MacAppDelegate

NSString *kSelectedTabKey = @"selectedTabKey";
NSString *kPlayerVolumeKey = @"playerVolumeKey";
NSString *kPlayerSpeedKey = @"playerSpeedKey";
NSString *kPlayerLoopKey = @"playerLoopKey";
NSString *kPlayerShuffleKey = @"playerShuffleKey";
NSString *kPlayerVoiceKey = @"playerVoiceKey";
NSString *kPlayerChordVoiceKey = @"playerChordVoiceKey";
NSString *kTuneSortOrderKey = @"tuneSortOrderKey";
NSString *kGuitarChordsKey = @"guitarChordsKey";
NSString *kLoopPlaybackKey = @"loopPlaybackKey";
NSString *kCurrentTuneKey = @"currentTuneKey";

int PaperWidth = 562;//FIXME-put somewhere sensible
int PaperHeight = 842;
int gTuneHeight;//FIXME

@synthesize window;

- (void) dealloc
{
  [plugins release];
  [super dealloc];
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
  // Initialize preferences
	NSString *testValue = [[NSUserDefaults standardUserDefaults] stringForKey:kPlayerVolumeKey];
	if ( testValue == nil ) {
		NSDictionary *appDefaults =  [NSDictionary dictionaryWithObjectsAndKeys:
      [NSNumber numberWithFloat:1], kPlayerVolumeKey,
      [NSNumber numberWithFloat:0], kPlayerVoiceKey,
      [NSNumber numberWithFloat:0], kPlayerChordVoiceKey,
      [NSNumber numberWithFloat:1], kPlayerSpeedKey,
      [NSNumber numberWithBool:0], kPlayerLoopKey,
      [NSNumber numberWithBool:0], kPlayerShuffleKey,
      [NSNumber numberWithBool:1], kGuitarChordsKey,
      [NSNumber numberWithBool:1], kLoopPlaybackKey,
      [NSNumber numberWithInteger:0], kSelectedTabKey,
      [NSNumber numberWithInteger:-1], kCurrentTuneKey,
      nil];
		
		[[NSUserDefaults standardUserDefaults] registerDefaults:appDefaults];
		[[NSUserDefaults standardUserDefaults] synchronize];
	}
//  NSBundle *myBundle = [NSBundle bundleForClass:[self class]];
//  [[NSHelpManager sharedHelpManager] registerBooksInBundle: myBundle];

//	if (![[PluginManager sharedManager] setupPython])
//		NSLog(@"Error: Can't start up Python plugins.");

  [[NSDocumentController sharedDocumentController] newDocument:self];
}

- (void)applicationWillTerminate:(NSNotification *)notification
{
  [[NSUserDefaults standardUserDefaults] synchronize];
}

- (NSArray*)getPlugins
{
  if ( plugins == nil ) {
    NSFileManager *fileManager = [NSFileManager defaultManager];
    NSBundle *bundle = [NSBundle mainBundle];
    NSString *pluginsPath = [bundle builtInPlugInsPath];
	
    NSArray *pluginFiles = [fileManager contentsOfDirectoryAtPath:pluginsPath error:NULL];
	
    plugins = [[NSMutableArray array] retain];
		for ( NSString *file in pluginFiles )
      if ( [[file pathExtension] caseInsensitiveCompare:@"py"] == NSOrderedSame )
        [plugins addObject:[pluginsPath stringByAppendingPathComponent:file]];
	
    [plugins sortUsingComparator:^NSComparisonResult(id obj1, id obj2) {
      id name1 = [[obj1 lastPathComponent] stringByDeletingPathExtension];
      id name2 = [[obj1 lastPathComponent] stringByDeletingPathExtension];
      return [name1 caseInsensitiveCompare: name2];
    }];
	}
  
	return plugins;
}

- (void)menuNeedsUpdate:(NSMenu*)menu
{
	[menu removeAllItems];
	
	for ( NSString *path in [self getPlugins] ) {
		NSString *name = [[path lastPathComponent] stringByDeletingPathExtension];
    NSMenuItem *item = [[[NSMenuItem alloc] initWithTitle:name action:@selector(runScript:) keyEquivalent:@""] autorelease];
    [item setRepresentedObject:path];
		[menu addItem:item];
	}
	
	if ( [menu numberOfItems] == 0 ) {
		NSMenuItem *item = [[[NSMenuItem alloc] initWithTitle:@"No Plugins" action:NULL keyEquivalent:@""] autorelease];
		[menu addItem:item];
	}
}

- (void)runScript:(NSMenuItem*)sender
{
//  PluginContext* context = [[[PluginContext alloc] init] autorelease];
//	PluginManager *pluginManager = [PluginManager sharedManager];
//	NSString *path = [sender representedObject];
//	BOOL success = [pluginManager loadScriptAtPath:path runFunction:@"main" withArguments:[NSArray arrayWithObject:context]];
//	if (!success)
//		NSRunAlertPanel(@"Can't Run Plugin", @"The plugin returned an unknown error.", nil, nil, nil);
}

- (BOOL)application:(NSApplication *)sender delegateHandlesKey:(NSString *)key
{
  if ([key isEqual:@"selectedABC"]) {
      return YES;
  } else if ([key isEqual:@"selectedTune"]) {
      return YES;
  } else {
      return NO;
  }
}

- (NSString*) selectedABC
{
  return @"Some ABC";
}

-  (BOOL) applicationShouldOpenUntitledFile:(NSApplication *)sender
{
  return NO;
}
@end
