/*
 *  This file is part of abc2ps,
 *  Copyright (C) 1996-2007  Michael Methfessel
 *  See file abc2ps.c for details.
 */

#include <time.h>
#include <string.h>

#include "abc2ps.h"
#include "syms.h"

#include "pssubs.h"

/*  subroutines for postscript output  */


/* ----- init_ps ------- */
void init_ps (FILE* fp, char str[], int is_epsf, float bx1, float by1,
              float bx2, float by2)
{
  file_initialized = 1;
}

/* ----- init_page: initialize postscript page ----- */
void init_page (FILE* fp)
{
  if (in_page)
    return;

  if ( musicSettings.write_music )
    graphicsBeginPage( gcx );
  in_page = 1;
  pagenum++;
}


/* ----- close_page-------- */
void close_page (FILE* fp)
{
  if (!in_page)
    return;
  in_page = 0;

  if ( musicSettings.write_music )
    graphicsEndPage( gcx );
}


/* ----- write_pagebreak ----- */
void write_pagebreak (FILE* fp)
{
  close_page (fp);
  init_page  (fp);
  posy = cfmt.pageheight - cfmt.topmargin;
}
